Create an issue with custom fields values

2011-04-20 10:04 - Stéphane Schoorens

Status: Closed Start date: 2011-04-20

Priority: Normal Due date:  

Assignee:  % Done: 100%

Category: REST API Estimated time: 0.00 hour

Target version:    

Resolution: Invalid   

Description

I need the custom field tag for a post action

related :

http://www.redmine.org/projects/redmine/wiki/Rest_Issues

History

#1 - 2011-04-20 10:53 - Etienne Massip

I think that it can be done ; did you try with

  <?xml version="1.0"?>

  <issue>

    <subject>Example</subject>

    <project_id>1</project_id>

    <priority_id>4</priority_id>

...

    <custom_values>

      <custom_value>

        <custom_field_id>2</custom_field_id>

        <value>Hello world !</value>

      </custom_value>

    </custom_values>

...

  </issue>

?

#2 - 2011-04-20 10:54 - Etienne Massip

- Subject changed from REST API for posting an issue to Create an issue with custom fields values

#3 - 2011-04-20 11:11 - Stéphane Schoorens

I use my REST API for transform name into id

I use this type of data :

my $valeurs = {

issue => {

tracker => 'Anomalie',

status => 'In Progress',

priority => 'Urgent',

subject => 'new',

description => 'helloworld,

category => 'Module',

project => 'test',

custom_values => {

custom_value => {

custom_field_id => 3,

value[or name] => '123',

},

},

},

};

i'm using a json encoded and i post it after

and custom values doesn't work .
http://www.redmine.org/projects/redmine/wiki/Rest_Issues


my api: https://github.com/sschoorens/Net--Redmine--API--REST

not yet on cpan i'm in dev

#4 - 2011-04-20 11:41 - Etienne Massip

custom_field_values is a safe attribute of Issue which requires the issue id as it's used for a many-to-many relationship and this case may not be

handled by code in IssueController#build_from_params@ (source:trunk/app/controllers/issues_controller.rb#L311).

Maybe a subsequent /edit POST request to add the custom values with new issue's id specified could do the job, not sure though.

#5 - 2011-04-20 12:36 - Stéphane Schoorens

I've tried to make a PUT request on a issue with that values :

my $refhash = {

issue => {

custom_values => {

custom_value => {

custom_field_id => 12,

value => 'france',

},

},

notes => 'put custom',

},

};

but just the notes was added.

#6 - 2011-04-20 12:37 - Stéphane Schoorens

I've tried to make a PUT request on a issue with that values :

@my $refhash = {

@            issue => {

@                          custom_values => {

@                                custom_value => {

@                                            custom_field_id => 12,

@                                            value => 'france',

@                                                    },

@                               },

@              notes => 'put custom',

@            },

@@        };

but just the notes was added.

#7 - 2011-04-20 12:38 - Stéphane Schoorens

double post sorry can you remove it ? and how include code with @@?

#8 - 2011-04-20 14:01 - Etienne Massip

Surround your multiline code with 

<pre><code class="javascript">...</code>

#9 - 2011-04-20 14:05 - Stéphane Schoorens

I've tried to make a PUT request on a issue with that values :

my $refhash = {

               issue => {

                         custom_values => {

                                           custom_value => {

                                                           custom_field_id => 12,

                                                           value => 'france',

                                                           },

                                          },

                         notes => 'put custom',

                         },

              };
but just the notes was added.

#10 - 2011-04-20 17:16 - Etienne Massip

Could you try to edit issue with PUT /issues/[issue_id].json of

{

  issue => {

    custom_values => {

      custom_value => {

        customized_type => 'issue',

        customized_id => [issue_id],

        custom_field => 'my custom field',

        value => 'france',

      },

    },

    notes => 'put custom',

  },

};

?

#11 - 2011-04-21 09:14 - Stéphane Schoorens

I've tried this on a custom field who's name 'Origine' :

  {

    issue => {

      custom_values => {

        custom_value => {

          customized_type => 'issue',

          customized_id => '424',

          custom_field => 'Origine',

          value => 'france',

        },

     },

     notes => 'put custom',

   },

  };

Only the notes is put.

#12 - 2011-04-21 09:33 - Stéphane Schoorens

This is the return of json encode of an issue :

"custom_fields":[{"value":"","name":"Resolution","id":2}]

so I've tested the same like this :

{

        issue => {

            custom_fields =>[ {

                           id => '12',

                           value => '',

                           name => 'france',

            } ],

            notes => 'put custom',

        },

      };

 but already only the notes are update.

#13 - 2011-05-25 20:54 - Etienne Massip

- Target version set to Candidate for next major release

#14 - 2011-05-26 00:32 - Etienne Massip

- Target version deleted (Candidate for next major release)
Could you please try the syntax described in RE: REST API json/xml syntax for updating/creating issues ?

#15 - 2011-05-26 14:59 - Stéphane Schoorens

- Status changed from New to Resolved

- % Done changed from 0 to 100

It works =p ! thanks you it works also with a POST

#16 - 2011-05-26 15:26 - Etienne Massip

If you have a few time, could you please add some doc about this in REST issues wiki page, that would be very nice ?

Or simply copy a full working example here so I could update wiki page myself.

Thanks !

#17 - 2011-05-26 15:26 - Etienne Massip

- Status changed from Resolved to Closed

- Resolution set to Invalid

#18 - 2011-05-26 15:42 - Stéphane Schoorens

I've add the field for custom value in the wiki where the posting with json is explain

#19 - 2011-05-26 15:44 - Etienne Massip

Thanks a lot !

#20 - 2018-01-03 21:20 - Curtis Weatherford

Stéphane Schoorens wrote:

I've add the field for custom value in the wiki where the posting with json is explain

 Could you please add a link to this because I can't seem to find it.
